commit 59bcc75f56ffeb9fa220f1eb53d45bf254258ac7
Author: Jeremy Harris <jgh146exb@wizmail.org>
Date:   Thu Feb 13 14:08:31 2020 +0000

    Auths: fix cyrus-sasl driver for gssapi use.  Bug 2524
    
    Broken-by: c0fb53b74e
    Cherry-picked from: 5c329a4388

diff --git a/src/src/auths/cyrus_sasl.c b/src/src/auths/cyrus_sasl.c
index 480010bab..19416a1bb 100644
--- a/src/src/auths/cyrus_sasl.c
+++ b/src/src/auths/cyrus_sasl.c
@@ -347,10 +347,10 @@ for (rc = SASL_CONTINUE; rc == SASL_CONTINUE; )
     }
   else
     {
-    /* make sure that we have a null-terminated string */
-    out2 = string_copyn(output, outlen);
+    /* auth_get_data() takes a length-specfied block of binary
+    which can include zeroes; no terminating NUL is needed */
 
-    if ((rc = auth_get_data(&input, out2, outlen)) != OK)
+    if ((rc = auth_get_data(&input, output, outlen)) != OK)
       {
       /* we couldn't get the data, so free up the library before
        * returning whatever error we get */

